package com.loafle.overflow.central.module.infra.service;

import com.loafle.overflow.central.commons.utils.PageUtil;
import com.loafle.overflow.central.module.infra.dao.InfraDAO;
import com.loafle.overflow.central.module.infra.dao.InfraHostDAO;
import com.loafle.overflow.central.module.infra.dao.InfraServiceDAO;
import com.loafle.overflow.central.module.infra.dao.InfraZoneDAO;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.probe.Probe;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.discovery.Host;
import com.loafle.overflow.model.discovery.Zone;
import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.model.infra.InfraHost;
import com.loafle.overflow.model.infra.InfraHostIP;
import com.loafle.overflow.model.infra.InfraZone;
import com.loafle.overflow.model.meta.MetaIPType;
import com.loafle.overflow.model.meta.MetaInfraType;
import com.loafle.overflow.model.meta.MetaTargetHostType;
import com.loafle.overflow.model.noauthprobe.NoAuthProbeDescription;
import com.loafle.overflow.model.noauthprobe.NoAuthProbeDescriptionHost;
import com.loafle.overflow.model.noauthprobe.NoAuthProbeDescriptionNetwork;
import com.loafle.overflow.service.central.infra.InfraService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service("InfraService")
public class CentralInfraService implements InfraService {

  @Autowired
  InfraDAO infraDAO;

  @Autowired
  InfraZoneDAO infraZoneDAO;

  @Autowired
  InfraHostDAO infraHostDAO;

  @Autowired
  InfraServiceDAO infraServiceDAO;

  @Override
  public Infra regist(Infra infra) throws OverflowException {
    return this.infraDAO.save(infra);
  }

  @Override
  public InfraZone registZone(Long probeID, Zone zone) throws OverflowException {
    InfraZone infraZone = this.infraZoneDAO.findByProbeIdAndNetwork(probeID, zone.getNetwork());
    if (null != infraZone) {
      return infraZone;
    }

    infraZone = new InfraZone();
    infraZone.setMetaInfraType(MetaInfraType.Enum.ZONE.to());

    return null;
  }

  @Override
  public InfraHost registHost(Long probeID, Host host) throws OverflowException {
    return null;
  }

  @Override
  public InfraService registService(Long probeID, com.loafle.overflow.model.discovery.Service service)
      throws OverflowException {
    return null;
  }

  @Override
  public List<Infra> registDiscoverd(Long probeID, List<Host> hosts,
      List<com.loafle.overflow.model.discovery.Service> services) throws OverflowException {
    return null;
  }

  public InfraHost registByNoAuthProbe(Long probeID, NoAuthProbeDescription noAuthProbeDescription)
      throws OverflowException {
    NoAuthProbeDescriptionNetwork networkInfo = noAuthProbeDescription.getNetwork();
    InfraHostIP infraHostIP = new InfraHostIP();
    // FIXME getting IPType from networkInfo
    infraHostIP.setMetaIPType(new MetaIPType((short) 1));
    infraHostIP.setAddress(networkInfo.getAddress());
    infraHostIP.setMac(networkInfo.getMacAddress());
    List<InfraHostIP> infraHostIPs = new ArrayList<>();
    infraHostIPs.add(infraHostIP);

    InfraHost infraHost = new InfraHost();
    infraHost.setProbe(new Probe(probeID));
    infraHost.setMetaInfraType(new MetaInfraType(1));
    infraHost.setMetaTargetHostType(new MetaTargetHostType(1));
    infraHost.setInfraHostIPs(infraHostIPs);

    return this.infraDAO.save(infraHost);
  }

  @Override
  public Infra read(Long id) throws OverflowException {
    return this.infraDAO.findById(id).get();
  }

  @Override
  public Page<Infra> readAllByProbeID(Long probeID, PageParams pageParams) throws OverflowException {
    return this.infraDAO.findAllByProbeId(probeID, PageUtil.getPageRequest(pageParams));
  }

  @Override
  public Page<Infra> readAllByDomainID(Long domainID, PageParams pageParams) throws OverflowException {
    return this.infraDAO.findAllByProbeDomainId(domainID, PageUtil.getPageRequest(pageParams));
  }

}
